//+------------------------------------------------------------------+
//|          DIZLC.mq4  Ver: 3.0   July 2009                         |         
//|    For use with DI and ZLC Trades                                |
//|                                                                  |
//|                                         formerly         MTP.mq4 |
//|                               Copyright  2006, Taylor Stockwell |
//|                                                    Version: 1.7  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Taylor Stockwell"
#property link      "stockwet@yahoo.com"
/* 
      -Ver 2.0 New Re-release.
               Input ATR manually.
    
       Ver 3.0 Added automatic ATR input.

Here is how this EA is supposed to work:               

 One order placed .3 lots (manually)
 (EA)
 SL set to 1/2 ATR
   
 1st TP = 1/2 ATR
 at 1/2 ATR, 
   1st .1 lots take profit and .2 lots runs,  SL is moved up to 1/2 ATR. Next TP set to Full ATR.
 at Full ATR,
   2nd .1 lots take profit and .1 lots runs either with a Trailer of 1/2 ATR or TP of 3x ATR. 
              
               
*/           

//=============== VARS external

extern double Close_Lots = 0.01;
//extern string com8 = "True=3x ATR, False=let run";
extern bool Third_profit = false;
extern bool Trailer = false;
extern bool Alert_Sound = false;
extern bool Alert_Email = false;
extern int Magic_Number=0;


//=============== VARS internal

string PreSet_Name = "DI/ZLC Trades";
string version="DIZLC 3.0  July 2009   ";
string trailon;
double Lots2Close;
int TP_Increment = 0;           //Bob says don't use?
int Close_Method = 1;           // Always use 1?
int First_Stop = 1;             // Always use 1?
int Third_Stop = 0;
int Third_Stop_Target = 0;
int Third_TP = 0;
int range = 5;
int Open_Spread=0;
int Close_Spread=0;
int Max_Pips=-99;
int ATR_half;
int First_TP; 
int Second_TP; 
int First_Stop_Target; 
int Second_Stop_Target; 
int Second_Stop;
int Trail_Stop_By; 
int Max_Loss;
int nextTP; 
int sl; 
int multiplier; 
int Trail_Stop; 
int Trail_Trigger; 
int temp;
int pipMult = 10000;


//=============== FUNCTION init
int init()
  {
  if (StringFind(Symbol(),"JPY",0) != -1)
   {
      pipMult = 100;
   }
 int ATR_full= pipMult * iATR(0,PERIOD_D1,14,0);   
         ATR_half=ATR_full/2;
         First_TP=ATR_half;
         First_Stop_Target=ATR_half;
         Second_Stop=ATR_half;
         Max_Loss=ATR_half;
         
         Second_TP=ATR_full;
         Second_Stop_Target=ATR_full;
         
   if(Third_profit)
     {
      Third_TP = ATR_full * 3;
      Third_Stop = ATR_full * 3;
     } 
     else 
     {
      Third_TP = 0;
      Third_Stop = 0;
     }
   if(Trailer) Trail_Stop_By = ATR_half;
   else Trail_Stop_By = 0;
           
   if(First_Stop==0 && First_Stop_Target !=0) First_Stop=1;
   if(Max_Loss < 0) Max_Loss=(-1*Max_Loss);
   if(Max_Loss==0)  Max_Loss=999;
   if(Trail_Stop_By < 0) Trail_Stop_By = -1*Trail_Stop_By;
   sl = -1*Max_Loss;
   
   if(First_TP!=0) nextTP = First_TP;
   else nextTP = TP_Increment;
   
   Trail_Stop = sl;
   trailon = "Off ";
   getMaxLoss();    // ???? Why is getMaxLoss function necessary? ~Lousan
   if(Third_Stop!=0) Trail_Trigger=Third_Stop+Trail_Stop_By;
   else if(Second_Stop!=0) Trail_Trigger=Second_Stop+Trail_Stop_By;
   else if(First_Stop!=0) Trail_Trigger=First_Stop+Trail_Stop_By;
   else Trail_Trigger=sl+Trail_Stop_By;
   Lots2Close = Close_Lots;
   
   
   Comment(version, 
   //"\nName: ", PreSet_Name,
   "\nATR:  ", ATR_full, "  ", ATR_half,
// "\nClose Method:  ", Close_Method,  
   "\nClose Lots:    ", Close_Lots,
   "\nTP:   ", First_TP, "  ", Second_TP, "  ",
               Third_TP, "  +", TP_Increment,
   "\nSL1:  ", First_Stop_Target, "  ", First_Stop,
   "\nSL2:  ", Second_Stop_Target, "  ", Second_Stop,
   "\nSL3:  ", Third_Stop_Target,  "  ", Third_Stop,
   "\nTSL:  ", Trail_Stop_By,
   "\nMax Loss:  ", Max_Loss);
  }
//== end function


//=============== FUNCTION deinit
int deinit()
  {
//----
   sl = -1*Max_Loss;
   nextTP = First_TP;
   Trail_Stop = sl;
//----
   return(0);
  }
//== end function

//========== FUNCTION Start
int start()
  {
//----
   getOpenOrders();
   getSpread();
   //Comment(sl);
//----
   return(0);
  }
//== end function

//========== FUNCTION getPipValue
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - 
NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point;
   return(val);
}
//== end function

//=========Function getSpread
int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   if(Open_Spread==0) Open_Spread=spread;
   Close_Spread=spread;
   return(spread);
}
//== end function




//==========Function getMaxLoss
int getMaxLoss()
{
   int calcMaxLoss;
   calcMaxLoss = Max_Loss;
   return(calcMaxLoss);
}
//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && 
            OrderSymbol() == Symbol()&&(Magic_Number==0 || Magic_Number == 
            OrderMagicNumber()))
         {
            double val=getPipValue(OrderOpenPrice(),OrderType());
            checkStops(val,OrderTicket());
            if(val > nextTP) takeProfit(val,OrderTicket());
         }

         if(Magic_Number == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+Magic_Number;


         if(sl==-1*Max_Loss)
            {
               nsl = First_Stop_Target;
               nsd = First_Stop;
            }
         else if(sl==First_Stop)
            {
               nsl = Second_Stop_Target;
               nsd = Second_Stop;
            } 
         else if(sl==Second_Stop)
            {
               nsl = Third_Stop_Target;
               nsd = Third_Stop;
            }
         else if(Trail_Stop_By != 0 && val >= Trail_Trigger)
            {
               nsl = val + 1;
               nsd = val + 1 - Trail_Stop_By; 
               trailon = " On";  
            }
         //RefreshRates();
         Comment(version, 
         "\nName: ", PreSet_Name,
//       "\nClose Method:  ", Close_Method,
         "\nClose Lots:    ", Close_Lots,
         "\nTP:   ", First_TP, "  ", Second_TP, "  ",
                     Third_TP, "  +", TP_Increment,
         "\nSL1:  ", First_Stop_Target, "  ", First_Stop,
         "\nSL2:  ", Second_Stop_Target, "  ", Second_Stop,
         "\nSL3:  ", Third_Stop_Target,  "  ", Third_Stop,
         "\nTSL:  ", Trail_Stop_By,
         "\nMax Loss:  ", Max_Loss,
         "\n----------------------------",
         "\nOrder Open: ",OrderOpenPrice(),
         "\nOpen Spread:  ",Open_Spread,
         "\nClose Spread:  ",Close_Spread,
         "\nMax Pips:    ",Max_Pips,
         "\nPip Count:   ", val,
         "\nNext TP:     ", nextTP, "   ", Lots2Close, " Lots",
         "\nCurr  SL:     ", sl,
         "\nTSL Trigger:   ", Trail_Trigger, "   ", trailon,
         "\nManaging:  ", mngMagic);


     }
}

//========== FUNCTION takeProfit
void takeProfit(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      if(pips >= nextTP)
      {
         if(Alert_Sound) PlaySound("mtp2.wav");
         if(OrderType()==1)    // 1 = OP_Sell
         {
            if(OrderClose(ticket, Lots2Close, Ask, 3, Lime)) temp=0;
            else Print("Error closing order : ",GetLastError());
         }
         else
         {
            if(OrderClose(ticket, Lots2Close, Bid, 3, Lime)) temp=0;
            else Print("Error closing order : ",GetLastError());
         }
         if(Close_Method==2) Lots2Close = Lots2Close + Close_Lots;
      
         if(nextTP == Third_TP) nextTP = nextTP + TP_Increment;
         else if (nextTP == Second_TP) nextTP = Third_TP;
         else if (nextTP == First_TP) nextTP = Second_TP;
         else nextTP = nextTP + TP_Increment;
      }
   }
}

//== end function



//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
   if(sl==-1*Max_Loss && First_Stop != 0 && pips >= First_Stop_Target)
   {
      moveStops(ticket, First_Stop);
   }
   else if(sl==First_Stop && First_Stop != 0 && pips >= Second_Stop_Target && Second_Stop !=0)
   {
      moveStops(ticket,Second_Stop);
   }
   else if(sl==Second_Stop && Second_Stop != 0 && pips >= Third_Stop_Target && Third_Stop !=0)
   {
      moveStops(ticket,Third_Stop);
   }
   else if(Trail_Stop_By != 0 && pips >= Trail_Trigger && pips - Trail_Stop_By > sl)
   {
      Trail_Stop = pips - Trail_Stop_By;
      sl = Trail_Stop;
      trailon = " ON";  
   }
   if(pips <= sl) stopTrade(pips,OrderTicket());  
   if(pips > Max_Pips) Max_Pips = pips;
   
}

//== end function

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==1)     // 1 = OP_Sell
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff*Point, 
OrderTakeProfit(),0,Plum);
      sl=stopDiff;
      }
      else
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff*Point, 
OrderTakeProfit(),0,Plum);
      sl=stopDiff;
      }
   }
}

//== end function

//========== FUNCTION killTrades
void stopTrade(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
       if(OrderType()==1) OrderClose(ticket,OrderLots(),Ask,3,DarkViolet);
       else OrderClose(ticket,OrderLots(),Bid,3,DarkViolet);
       
       if(Alert_Email) SendMail("DIZLC:  Trade Stopped "+pips," ");
       if(Alert_Sound) 
          if(pips > 0) PlaySound("mtp3.wav");
          else PlaySound("mtp1.wav");
          
   }
}
//== end function